package library;

import java.io.IOException;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Control01 extends HttpServlet {
	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
	{
		req.setCharacterEncoding("UTF-8");
		ServletContext app = getServletContext();
		Library01 library = (Library01)app.getAttribute("library01");
		if(library == null){
			library = new Library01();
			app.setAttribute("library01", library);
		}
		String ope = req.getParameter("ope");
		Result01 ret = null;
		if(ope.equals("addmember")){
			String name = req.getParameter("name");
			ret = library.addMember(name);
		}else if(ope.equals("removemember")){
			String mcode = req.getParameter("mcode");
			ret = library.removeMember(mcode);
		}else if(ope.equals("showmembers")){
			ret = library.showMembers();
		}else if(ope.equals("showmember")){
			String mcode = req.getParameter("mcode");
			ret = library.showMember(mcode);
		}else if(ope.equals("addbkind")){
			String isbn = req.getParameter("isbn");
			String title = req.getParameter("title");
			ret = library.addBkind(isbn, title);
		}else if(ope.equals("removebkind")){
			String isbn = req.getParameter("isbn");
			ret = library.removeBkind(isbn);
		}else if(ope.equals("showbkinds")){
			ret = library.showBkinds();
		}else if(ope.equals("addbook")){
			String isbn = req.getParameter("isbn");
			ret = library.addBook(isbn);
		}else if(ope.equals("removebook")){
			String bcode = req.getParameter("bcode");
			ret = library.removeBook(bcode);
		}else if(ope.equals("showbooks")){
			ret = library.showBooks();
		}else if(ope.equals("keepbook")){
			String mcode = req.getParameter("mcode");
			String bcode = req.getParameter("bcode");
			ret = library.keepBook(mcode, bcode);
		}else if(ope.equals("returnbook")){
			String bcode = req.getParameter("bcode");
			ret = library.returnBook(bcode);
		}
		String[] mes = {
			"処理が正常に終了しました",
			"会員番号が不正です",
			"その会員に未返却の本があります",
			"ISBN番号が重複しています",
			"ISBN番号が不正です",
			"その本の種類に未返却の本があります",
			"本番号が不正です",
			"その本は貸し出し中です",
			"その本を貸出しされていません"
		};
		req.setAttribute("message", mes);
		req.setAttribute("result", ret);
		req.getRequestDispatcher("/library/Result01.jsp").forward(req, res);
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
	{
		doGet(req, res);
	}
}
