package library;

import java.util.LinkedList;
import java.util.TreeMap;

class Member01 {
	private String code;
	private String name;
	private TreeMap<String, Book01> books = new TreeMap<String, Book01>();

	Member01(String code, String name){
		this.code = code;
		this.name = name;
	}
	String getCode(){ return code; }
	String getName(){ return name; }

	int getNumber(){ return books.size(); }

	void keepBook(Book01 book){
		books.put(book.getCode(), book);
	}
	void returnBook(Book01 book){
		books.remove(book.getCode());
	}

	LinkedList<String[]> getBooksInfo(){
		LinkedList<String[]> info = new LinkedList<String[]>();
		info.add(new String[]{"本番号", "ISBN番号", "タイトル"});
		for(Book01 book: books.values()){
			String code = book.getCode();
			String isbn = book.getBkind().getIsbn();
			String title = book.getBkind().getTitle();
			info.add(new String[]{code, isbn, title});
		}
		return info;
	}
}