package bank;

import java.util.*;

class Bank01 {
	private int cur_num = 5640000;
	private Map accounts = new TreeMap();

	Result01 open(String name){
		Result01 ret = new Result01();
		cur_num++;
		String acc_num = Integer.toString(cur_num);
		accounts.put(acc_num, new Account01(acc_num, name));
		ret.addInfo(new String[]{"口座番号", acc_num});
		return ret;
	}

	Result01 close(String acc_num){
		Result01 ret = new Result01();
		if(accounts.remove(acc_num) == null){
			ret.setCode(Result01.NO_ACCOUNT);
		}
		return ret;
	}

	Result01 showAccounts(){
		Result01 ret = new Result01();
		ret.addInfo(new String[]{"口座番号", "名前"});
		Iterator it = accounts.values().iterator();
		while(it.hasNext()){
			Account01 acc = (Account01)it.next();
			ret.addInfo(new String[]{acc.getNumber(), acc.getName()});
		}
		return ret;
	}

	Result01 inquiry(String acc_num){
		Account01 acc = (Account01)accounts.get(acc_num);
		Result01 ret = new Result01();
		if(acc == null){
			ret.setCode(Result01.NO_ACCOUNT);
			return ret;
		}
		ret.addInfo(new String[]{"お名前", acc.getName()}); 
		ret.addInfo(new String[]{"残高", Integer.toString(acc.getBalance())}); 
		return ret;
	}

	Result01 deposit(String acc_num, int price){
		Account01 acc = (Account01)accounts.get(acc_num);
		Result01 ret = new Result01();
		if(acc == null){
			ret.setCode(Result01.NO_ACCOUNT);
		}
		acc.add(price);
		return ret;
	}

	Result01 withdraw(String acc_num, int price){
		Account01 acc = (Account01)accounts.get(acc_num);
		Result01 ret = new Result01();
		if(acc == null){
			ret.setCode(Result01.NO_ACCOUNT);
			return ret;
		}
		if(acc.getBalance() < price){
			ret.setCode(Result01.NO_BALANCE);
			return ret;
		}
		acc.add(-price);
		return ret;
	}
}
