package bank;

import java.util.*;
import java.io.*;

class Service01 {
	void service(){
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		Bank01 bank = new Bank01();
		while(true){
			System.out.println();
			System.out.println("行いたい操作を選択して下さい");
			System.out.println("\t1.終了");
			System.out.println("\t2.口座開設  3.口座解約  4.口座一覧  5.口座照会");
			System.out.println("\t6.預け入れ  7.引き出し");
			System.out.print("=> ");
			try{
				String acc_num;
				int price;
				Result01 ret = null;
				int ope = Integer.parseInt(readLine(br));
				switch(ope){
				case 1:
					return;
				case 2:
					System.out.print("--- お名前を入力して下さい => ");
					ret = bank.open(readLine(br));
					break;
				case 3:
					System.out.print("--- 口座番号を入力して下さい => ");
					ret = bank.close(readLine(br));
					break;
				case 4:
					ret = bank.showAccounts();
					break;
				case 5:
					System.out.print("--- 口座番号を入力して下さい => ");
					ret = bank.inquiry(readLine(br));
					break;
				case 6:
					System.out.print("--- 口座番号を入力して下さい => ");
					acc_num = readLine(br);
					System.out.print("--- 金額を入力して下さい => ");
					price = Integer.parseInt(readLine(br));
					ret = bank.deposit(acc_num, price);
					break;
				case 7:
					System.out.print("--- 口座番号を入力して下さい => ");
					acc_num = readLine(br);
					System.out.print("--- 金額を入力して下さい => ");
					price = Integer.parseInt(readLine(br));
					ret = bank.withdraw(acc_num, price);
					break;
				default:
					System.out.println("*** 1から7までの数字を入力して下さい !!!!");
					continue;
				}


				switch(ret.getCode()){
				case Result01.OK:
					System.out.println("*** 処理が正常に終了しました");
					break;
				case Result01.NO_ACCOUNT:
					System.out.println("*** 口座が存在しません");
					break;
				case Result01.NO_BALANCE:
					System.out.println("*** 残高が不足しています");
					break;
				}

				List info = ret.getInfo();
				if(info == null){
					continue;
				}
				for(int i = 0; i < info.size(); i++){
					System.out.print("\t");
					String[] row = (String[])ret.getInfo().get(i);
					for(int j = 0; j < row.length; j++){
						System.out.print(row[j]);
						System.out.print(j == row.length -1 ? "" : " : ");
					}
					System.out.println();
				}
			}catch(NumberFormatException ex){
				System.out.println("*** 数字を入力して下さい !!!!");
			}catch(Exception ex){
				ex.printStackTrace();
			}
		}
	}

	private String readLine(BufferedReader br){
		while(true){
			try{
				String input = br.readLine().trim();
				if(input.equals("")){
					System.out.print("--- 空白ではない文字列を入力して下さい => ");
					continue;
				}
				return input;
			}catch(IOException ex){
				ex.printStackTrace();
			}
		}
	}
}
