package circle;

import java.util.LinkedList;
import java.util.Scanner;

public class Service01 {
	public static void main(String[] args){
		Scanner sc = new Scanner(System.in);
		Circle01 circle = new Circle01();
		while(true){
			System.out.println();
			System.out.println("行いたい操作を選択して下さい");
			System.out.println("\t1.終了");
			System.out.println("\t2.会員を追加  3.会員を削除  4.会員を表示");
			System.out.print("=> ");
			int ope;
			try{
				ope = Integer.parseInt(read(sc));
			}catch(NumberFormatException ex){
				System.out.println("*** 数字を入力して下さい !!!!");
				continue;
			}

			Result01 ret = null;

			switch(ope){
			case 1: // 終了
				return;
			case 2: // 会員登録
				System.out.print("--- お名前を入力して下さい => ");
				ret = circle.addMember(read(sc));
				break;
			case 3: // 会員削除
				System.out.print("--- 会員番号を入力して下さい => ");
				ret = circle.removeMember(read(sc));
				break;
			case 4: // 会員表示
				ret = circle.showMembers();
				break;
			default:
				System.out.println("*** 1から4までの数字を入力して下さい !!!!");
				continue;
			}

			switch(ret.getCode()){
			case Result01.OK:
				System.out.println("*** 処理が正常に終了しました");
				break;
			case Result01.NO_MEMBER:
				System.out.println("*** そのような番号の会員はいません");
				break;
			}

			LinkedList<String[]> info = ret.getInfo();
			if(info == null){
				continue;
			}
			for(String[] row: info){
				System.out.print("\t");
				boolean first = true;
				for(String s: row){
					System.out.print(first ? "" : " : ");
					first = false;
					System.out.print(s);
				}
				System.out.println();
			}
		}
	}

	private static String read(Scanner br){
		while(true){
			String input = br.nextLine().trim();
			if(input.equals("")){
				System.out.print("--- 空白ではない文字列を入力して下さい => ");
				continue;
			}
			return input;
		}
	}
}