package league;

import java.util.*;
import java.io.*;

public class Service01 {
	public void service(){
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		League01 league = new League01();
		while(true){
			System.out.println();
			System.out.println("行いたい操作を選択して下さい");
			System.out.println("\t1.終了");
			System.out.println("\t2.選手登録  3.選手抹消  4.選手情報");
			System.out.println("\t5.試合開始  6.試合終了・記録");
			System.out.println("\t7.現在の試合状況  8.試合の結果閲覧");
			System.out.print("=> ");

			int ope;
			Result01 ret = null;
			String code1;
			String code2;

			try{
				ope = Integer.parseInt(readLine(br));
			}catch(NumberFormatException ex){
				System.out.println("*** 数字を入力して下さい !!!!");
				continue;
			}

			switch(ope){
			case 1:
				return;
			case 2: // 選手登録
				System.out.print("--- 名前を入力して下さい => ");
				ret = league.addPlayer(readLine(br));
				break;
			case 3: // 選手抹消
				System.out.print("--- 選手番号を入力して下さい => ");
				ret = league.removePlayer(readLine(br));
				break;
			case 4: // 選手情報
				ret = league.showPlayers();
				break;
			case 5: // 試合開始
				System.out.print("--- 一人目の選手番号を入力して下さい => ");
				code1 = readLine(br);
				System.out.print("--- 二人目の選手番号を入力して下さい => ");
				code2 = readLine(br);
				ret = league.beginMatch(code1, code2);
				break;
			case 6: // 試合終了・記録
				System.out.print("--- 試合番号を入力して下さい => ");
				String code = readLine(br);
				ret = league.getMatch(code);
				if(ret.getCode() != Result01.OK){
					break;
				}
				String[] player;
				player = (String[])ret.getInfo().get(0);
				System.out.print(player[0] + "のスコアを入力して下さい => ");
				int score1 = Integer.parseInt(readLine(br));
				player = (String[])ret.getInfo().get(1);
				System.out.print(player[0] + "のスコアを入力して下さい => ");
				int score2 = Integer.parseInt(readLine(br));
				ret = league.endMatch(code, score1, score2);
				break;
			case 7: // 現在の試合状況
				ret = league.showCurMatches();
				break;
			case 8: // 試合の結果閲覧
				ret = league.showRecMatches();
				break;
			default:
				System.out.println("*** 1から8までの数字を入力して下さい !!!!");
				continue;
			}

			switch(ret.getCode()){
			case Result01.OK:
				System.out.println("*** 処理が正常に終了しました");
				break;
			case Result01.NO_PLAYER:
				System.out.println("*** そのような番号の選手はいません");
				break;
			case Result01.BUSY_PLAYER:
				System.out.println("*** その選手は試合中です");
				break;
			case Result01.NO_TWO_PLAYER:
				System.out.println("*** どちらかまたは両方の選手が存在しません");
				break;
			case Result01.BUSY_EITHER_PLAYER:
				System.out.println("*** どちらかまたは両方の選手が試合中です");
				break;
			case Result01.DUP_PLAYER:
				System.out.println("*** 選手が重複しています");
				break;
			case Result01.NO_MATCH:
				System.out.println("*** 現在、そのような番号の試合はありません");
				break;
			}

			List info = ret.getInfo();
			if(info == null){
				continue;
			}
			for(int i = 0; i < info.size(); i++){
				System.out.print("\t");
				String[] row = (String[])ret.getInfo().get(i);
				for(int j = 0; j < row.length; j++){
					System.out.print(row[j]);
					System.out.print(j == row.length - 1 ? "" : " : ");
				}
				System.out.println();
			}
		}
	}

	private String readLine(BufferedReader br){
		while(true){
			try{
				String input = br.readLine().trim();
				if(input.equals("")){
					System.out.print("--- 空白ではない文字列を入力して下さい => ");
					continue;
				}
				return input;
			}catch(IOException ex){
				ex.printStackTrace();
			}
		}
	}
}
