package library;

import java.util.LinkedList;
import java.util.Scanner;

public class Service01 {
	public static void main(String[] args){
		Scanner sc = new Scanner(System.in);
		Library01 library = new Library01();
		while(true){
			System.out.println();
			System.out.println("行いたい操作を選択して下さい");
			System.out.println("\t1.終了");
			System.out.println("\t2.会員を追加  3.会員を削除  4.会員の一覧を表示  5.会員の詳細を表示");
			System.out.println("\t6.本の種類を追加  7.本の種類を削除  8.本の種類の一覧を表示");
			System.out.println("\t9.本を追加  10.本を削除  11.本の一覧を表示");
			System.out.println("\t12.本を借りる  13.本を返す");
			System.out.print("=> ");

			int ope;
			Result01 ret = null;
			String mcode;
			String isbn;
			String title;
			String bcode;

			try{
				ope = Integer.parseInt(read(sc));
			}catch(NumberFormatException ex){
				System.out.println("*** 数字を入力して下さい !!!!");
				continue;
			}

			switch(ope){
			case 1: // 終了
				return;
			case 2: // 会員登録
				System.out.print("--- お名前を入力して下さい => ");
				ret = library.addMember(read(sc));
				break;
			case 3: // 会員削除
				System.out.print("--- 会員番号を入力して下さい => ");
				ret = library.removeMember(read(sc));
				break;
			case 4: // 会員情報
				ret = library.showMembers();
				break;
			case 5: // 会員情報詳細
				System.out.print("--- 会員番号を入力して下さい => ");
				ret = library.showMember(read(sc));
				break;
			case 6: // 本種類登録
				System.out.print("--- ISBN番号を入力して下さい => ");
				isbn = read(sc);
				System.out.print("--- 本のタイトルを入力して下さい => ");
				title = read(sc);
				ret = library.addBkind(isbn, title);
				break;
			case 7: // 本種類削除
				System.out.print("--- ISBN番号を入力して下さい => ");
				ret = library.removeBkind(read(sc));
				break;
			case 8: // 本種類情報
				ret = library.showBkinds();
				break;
			case 9: // 本追加
				System.out.print("--- ISBN番号を入力して下さい => ");
				ret = library.addBook(read(sc));
				break;
			case 10: // 本破棄
				System.out.print("--- 本番号を入力して下さい => ");
				ret = library.removeBook(read(sc));
				break;
			case 11: // 本情報
				ret = library.showBooks();
				break;
			case 12: // 賃借
				System.out.print("--- 会員番号を入力して下さい => ");
				mcode = read(sc);
				System.out.print("--- 本番号を入力して下さい => ");
				bcode = read(sc);
				ret = library.keepBook(mcode, bcode);
				break;
			case 13: //返却
				System.out.print("--- 本番号を入力して下さい => ");
				ret = library.returnBook(read(sc));
				break;
			default:
				System.out.println("*** 1から13までの数字を入力して下さい !!!!");
				continue;
			}

			switch(ret.getCode()){
			case Result01.OK:
				System.out.println("*** 処理が正常に終了しました");
				break;
			case Result01.NO_MEMBER:
				System.out.println("*** 会員番号が不正です");
				break;
			case Result01.AVL_MEMBER:
				System.out.println("*** その会員に未返却の本があります");
				break;
			case Result01.DUP_BKIND:
				System.out.println("*** ISBN番号が重複しています");
				break;
			case Result01.NO_BKIND:
				System.out.println("*** ISBN番号が不正です");
				break;
			case Result01.AVL_BKIND:
				System.out.println("*** その本の種類に未返却の本があります");
				break;
			case Result01.NO_BOOK:
				System.out.println("*** 本番号が不正です");
				break;
			case Result01.BUSY_BOOK:
				System.out.println("*** その本は貸し出し中です");
				break;
			case Result01.NOTKEEP_BOOK:
				System.out.println("*** その本を貸出しされていません");
				break;
			}

			LinkedList<String[]> info = ret.getInfo();
			if(info == null){
				continue;
			}
			for(String[] row: info){
				System.out.print("\t");
				boolean first = true;
				for(String s: row){
					System.out.print(first ? "" : " : ");
					first = false;
					System.out.print(s);
				}
				System.out.println();
			}
		}
	}

	private static String read(Scanner br){
		while(true){
			String input = br.nextLine().trim();
			if(input.equals("")){
				System.out.print("--- 空白ではない文字列を入力して下さい => ");
				continue;
			}
			return input;
		}
	}
}